/* PluginManager.c generated by valac 0.18.1, the Vala compiler
 * generated from PluginManager.vala, do not modify */

/*
 * Copyright (C) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org> (from Rygel)
 *
 * This file is part of Marlin.
 *
 * Marlin is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Marlin is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gmodule.h>
#include "gof-file.h"


#define MARLIN_TYPE_PLUGIN_MANAGER (marlin_plugin_manager_get_type ())
#define MARLIN_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_TYPE_PLUGIN_MANAGER, MarlinPluginManager))
#define MARLIN_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_TYPE_PLUGIN_MANAGER, MarlinPluginManagerClass))
#define MARLIN_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_TYPE_PLUGIN_MANAGER))
#define MARLIN_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_TYPE_PLUGIN_MANAGER))
#define MARLIN_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_TYPE_PLUGIN_MANAGER, MarlinPluginManagerClass))

typedef struct _MarlinPluginManager MarlinPluginManager;
typedef struct _MarlinPluginManagerClass MarlinPluginManagerClass;
typedef struct _MarlinPluginManagerPrivate MarlinPluginManagerPrivate;

#define MARLIN_PLUGINS_TYPE_BASE (marlin_plugins_base_get_type ())
#define MARLIN_PLUGINS_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MARLIN_PLUGINS_TYPE_BASE, MarlinPluginsBase))
#define MARLIN_PLUGINS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MARLIN_PLUGINS_TYPE_BASE, MarlinPluginsBaseClass))
#define MARLIN_PLUGINS_IS_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MARLIN_PLUGINS_TYPE_BASE))
#define MARLIN_PLUGINS_IS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MARLIN_PLUGINS_TYPE_BASE))
#define MARLIN_PLUGINS_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MARLIN_PLUGINS_TYPE_BASE, MarlinPluginsBaseClass))

typedef struct _MarlinPluginsBase MarlinPluginsBase;
typedef struct _MarlinPluginsBaseClass MarlinPluginsBaseClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
#define _marlin_plugins_base_unref0(var) ((var == NULL) ? NULL : (var = (marlin_plugins_base_unref (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MarlinPluginManager {
	GObject parent_instance;
	MarlinPluginManagerPrivate * priv;
	GList* menus;
};

struct _MarlinPluginManagerClass {
	GObjectClass parent_class;
};

struct _MarlinPluginManagerPrivate {
	GeeHashMap* plugin_hash;
	GSettings* settings;
	gchar* settings_field;
	gchar* plugin_dir;
	GeeList* names;
	gboolean in_available;
};

typedef MarlinPluginsBase* (*MarlinPluginManagerModuleInitFunc) (void* user_data);

extern MarlinPluginManager* plugins;
MarlinPluginManager* plugins = NULL;
static gpointer marlin_plugin_manager_parent_class = NULL;

GType marlin_plugin_manager_get_type (void) G_GNUC_CONST;
gpointer marlin_plugins_base_ref (gpointer instance);
void marlin_plugins_base_unref (gpointer instance);
GParamSpec* marlin_plugins_param_spec_base (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void marlin_plugins_value_set_base (GValue* value, gpointer v_object);
void marlin_plugins_value_take_base (GValue* value, gpointer v_object);
gpointer marlin_plugins_value_get_base (const GValue* value);
GType marlin_plugins_base_get_type (void) G_GNUC_CONST;
#define MARLIN_PLUGIN_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), MARLIN_TYPE_PLUGIN_MANAGER, MarlinPluginManagerPrivate))
enum  {
	MARLIN_PLUGIN_MANAGER_DUMMY_PROPERTY
};
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
MarlinPluginManager* marlin_plugin_manager_new (GSettings* settings, const gchar* field, const gchar* plugin_dir);
MarlinPluginManager* marlin_plugin_manager_construct (GType object_type, GSettings* settings, const gchar* field, const gchar* plugin_dir);
void marlin_plugin_manager_load_plugins (MarlinPluginManager* self);
static void marlin_plugin_manager_load_modules_from_dir (MarlinPluginManager* self, const gchar* path, gboolean force);
static void marlin_plugin_manager_load_plugin_keyfile (MarlinPluginManager* self, const gchar* path, const gchar* parent, gboolean force);
static void marlin_plugin_manager_load_module (MarlinPluginManager* self, const gchar* file_path);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
void marlin_plugin_manager_hook_context_menu (MarlinPluginManager* self, GtkWidget* menu, GList* files);
void marlin_plugins_base_context_menu (MarlinPluginsBase* self, GtkWidget* widget, GList* files);
void marlin_plugin_manager_ui (MarlinPluginManager* self, GtkUIManager* data);
void marlin_plugins_base_ui (MarlinPluginsBase* self, GtkUIManager* widget);
void marlin_plugin_manager_directory_loaded (MarlinPluginManager* self, void* path);
void marlin_plugins_base_directory_loaded (MarlinPluginsBase* self, void* data);
void marlin_plugin_manager_interface_loaded (MarlinPluginManager* self, GtkWidget* win);
void marlin_plugins_base_interface_loaded (MarlinPluginsBase* self, GtkWidget* widget);
void marlin_plugin_manager_update_sidebar (MarlinPluginManager* self, GtkWidget* win);
void marlin_plugins_base_update_sidebar (MarlinPluginsBase* self, GtkWidget* sidebar);
void marlin_plugin_manager_update_file_info (MarlinPluginManager* self, GOFFile* file);
void marlin_plugins_base_update_file_info (MarlinPluginsBase* self, GOFFile* file);
void marlin_plugin_manager_add_plugin (MarlinPluginManager* self, const gchar* path);
void marlin_plugin_manager_load_plugin (MarlinPluginManager* self, const gchar* path);
GeeList* marlin_plugin_manager_get_available_plugins (MarlinPluginManager* self);
gboolean marlin_plugin_manager_disable_plugin (MarlinPluginManager* self, const gchar* path);
static void marlin_plugin_manager_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


MarlinPluginManager* marlin_plugin_manager_construct (GType object_type, GSettings* settings, const gchar* field, const gchar* plugin_dir) {
	MarlinPluginManager * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	GeeArrayList* _tmp7_;
	g_return_val_if_fail (settings != NULL, NULL);
	g_return_val_if_fail (field != NULL, NULL);
	g_return_val_if_fail (plugin_dir != NULL, NULL);
	self = (MarlinPluginManager*) g_object_new (object_type, NULL);
	_tmp0_ = field;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->settings_field);
	self->priv->settings_field = _tmp1_;
	_tmp2_ = settings;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp3_;
	_tmp4_ = plugin_dir;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (self->priv->plugin_dir);
	self->priv->plugin_dir = _tmp5_;
	_tmp6_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, MARLIN_PLUGINS_TYPE_BASE, (GBoxedCopyFunc) marlin_plugins_base_ref, marlin_plugins_base_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->plugin_hash);
	self->priv->plugin_hash = _tmp6_;
	_tmp7_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
	_g_object_unref0 (self->priv->names);
	self->priv->names = (GeeList*) _tmp7_;
	return self;
}


MarlinPluginManager* marlin_plugin_manager_new (GSettings* settings, const gchar* field, const gchar* plugin_dir) {
	return marlin_plugin_manager_construct (MARLIN_TYPE_PLUGIN_MANAGER, settings, field, plugin_dir);
}


void marlin_plugin_manager_load_plugins (MarlinPluginManager* self) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->plugin_dir;
	_tmp1_ = g_strconcat (_tmp0_, "/core/", NULL);
	_tmp2_ = _tmp1_;
	marlin_plugin_manager_load_modules_from_dir (self, _tmp2_, TRUE);
	_g_free0 (_tmp2_);
	self->priv->in_available = TRUE;
	_tmp3_ = self->priv->plugin_dir;
	marlin_plugin_manager_load_modules_from_dir (self, _tmp3_, FALSE);
	self->priv->in_available = FALSE;
}


static void marlin_plugin_manager_load_modules_from_dir (MarlinPluginManager* self, const gchar* path, gboolean force) {
	const gchar* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* dir;
	gchar* _tmp2_;
	gchar* attributes;
	GFileInfo* info = NULL;
	GFileEnumerator* enumerator = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = path;
	_tmp1_ = g_file_new_for_path (_tmp0_);
	dir = _tmp1_;
	_tmp2_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE);
	attributes = _tmp2_;
	{
		GFile* _tmp3_;
		const gchar* _tmp4_;
		GFileEnumerator* _tmp5_ = NULL;
		GFileEnumerator* _tmp6_;
		GFileEnumerator* _tmp7_;
		GFileInfo* _tmp8_ = NULL;
		GFileInfo* _tmp9_;
		_tmp3_ = dir;
		_tmp4_ = attributes;
		_tmp5_ = g_file_enumerate_children (_tmp3_, _tmp4_, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		_tmp6_ = _tmp5_;
		if (_inner_error_ != NULL) {
			goto __catch7_g_error;
		}
		_g_object_unref0 (enumerator);
		enumerator = _tmp6_;
		_tmp7_ = enumerator;
		_tmp8_ = g_file_enumerator_next_file (_tmp7_, NULL, &_inner_error_);
		_tmp9_ = _tmp8_;
		if (_inner_error_ != NULL) {
			goto __catch7_g_error;
		}
		_g_object_unref0 (info);
		info = _tmp9_;
		while (TRUE) {
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			const gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			gchar* file_name;
			GFile* _tmp14_;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			gchar* file_path;
			const gchar* _tmp20_;
			gboolean _tmp21_ = FALSE;
			GFileEnumerator* _tmp27_;
			GFileInfo* _tmp28_ = NULL;
			GFileInfo* _tmp29_;
			_tmp10_ = info;
			if (!(_tmp10_ != NULL)) {
				break;
			}
			_tmp11_ = info;
			_tmp12_ = g_file_info_get_name (_tmp11_);
			_tmp13_ = g_strdup (_tmp12_);
			file_name = _tmp13_;
			_tmp14_ = dir;
			_tmp15_ = g_file_get_path (_tmp14_);
			_tmp16_ = _tmp15_;
			_tmp17_ = file_name;
			_tmp18_ = g_build_filename (_tmp16_, _tmp17_, NULL);
			_tmp19_ = _tmp18_;
			_g_free0 (_tmp16_);
			file_path = _tmp19_;
			_tmp20_ = file_name;
			_tmp21_ = g_str_has_suffix (_tmp20_, ".plug");
			if (_tmp21_) {
				const gchar* _tmp22_;
				GFile* _tmp23_;
				gchar* _tmp24_ = NULL;
				gchar* _tmp25_;
				gboolean _tmp26_;
				_tmp22_ = file_path;
				_tmp23_ = dir;
				_tmp24_ = g_file_get_path (_tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = force;
				marlin_plugin_manager_load_plugin_keyfile (self, _tmp22_, _tmp25_, _tmp26_);
				_g_free0 (_tmp25_);
			}
			_tmp27_ = enumerator;
			_tmp28_ = g_file_enumerator_next_file (_tmp27_, NULL, &_inner_error_);
			_tmp29_ = _tmp28_;
			if (_inner_error_ != NULL) {
				_g_free0 (file_path);
				_g_free0 (file_name);
				goto __catch7_g_error;
			}
			_g_object_unref0 (info);
			info = _tmp29_;
			_g_free0 (file_path);
			_g_free0 (file_name);
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* _error_ = NULL;
		GFile* _tmp30_;
		gchar* _tmp31_ = NULL;
		gchar* _tmp32_;
		GError* _tmp33_;
		const gchar* _tmp34_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp30_ = dir;
		_tmp31_ = g_file_get_path (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = _error_;
		_tmp34_ = _tmp33_->message;
		g_critical ("PluginManager.vala:84: Error listing contents of folder '%s': %s", _tmp32_, _tmp34_);
		_g_free0 (_tmp32_);
		_g_error_free0 (_error_);
	}
	__finally7:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (enumerator);
		_g_object_unref0 (info);
		_g_free0 (attributes);
		_g_object_unref0 (dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (enumerator);
	_g_object_unref0 (info);
	_g_free0 (attributes);
	_g_object_unref0 (dir);
}


static void marlin_plugin_manager_load_module (MarlinPluginManager* self, const gchar* file_path) {
	const gchar* _tmp0_;
	GModule* _tmp1_ = NULL;
	GModule* module;
	GModule* _tmp2_;
	void* function = NULL;
	GModule* _tmp5_;
	void* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	void* _tmp10_;
	MarlinPluginManagerModuleInitFunc module_init;
	void* module_init_target;
	MarlinPluginManagerModuleInitFunc _tmp11_;
	void* _tmp11__target;
	GModule* _tmp12_;
	MarlinPluginManagerModuleInitFunc _tmp13_;
	void* _tmp13__target;
	MarlinPluginsBase* _tmp14_ = NULL;
	MarlinPluginsBase* plug;
	GModule* _tmp15_;
	const gchar* _tmp16_ = NULL;
	MarlinPluginsBase* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file_path != NULL);
	_tmp0_ = file_path;
	_tmp1_ = g_module_open (_tmp0_, G_MODULE_BIND_LOCAL);
	module = _tmp1_;
	_tmp2_ = module;
	if (_tmp2_ == NULL) {
		const gchar* _tmp3_;
		const gchar* _tmp4_ = NULL;
		_tmp3_ = file_path;
		_tmp4_ = g_module_error ();
		g_warning ("PluginManager.vala:96: Failed to load module from path '%s': %s", _tmp3_, _tmp4_);
		_g_module_close0 (module);
		return;
	}
	_tmp5_ = module;
	_tmp7_ = g_module_symbol (_tmp5_, "module_init", &_tmp6_);
	function = _tmp6_;
	if (!_tmp7_) {
		const gchar* _tmp8_;
		const gchar* _tmp9_ = NULL;
		_tmp8_ = file_path;
		_tmp9_ = g_module_error ();
		g_warning ("PluginManager.vala:105: Failed to find entry point function '%s' in '%" \
"s': %s", "module_init", _tmp8_, _tmp9_);
		_g_module_close0 (module);
		return;
	}
	_tmp10_ = function;
	module_init = (MarlinPluginManagerModuleInitFunc) _tmp10_;
	module_init_target = NULL;
	_tmp11_ = module_init;
	_tmp11__target = module_init_target;
	_vala_assert (_tmp11_ != NULL, "module_init != null");
	_tmp12_ = module;
	g_module_make_resident (_tmp12_);
	_tmp13_ = module_init;
	_tmp13__target = module_init_target;
	_tmp14_ = _tmp13_ (_tmp13__target);
	plug = _tmp14_;
	_tmp15_ = module;
	_tmp16_ = g_module_name (_tmp15_);
	g_debug ("PluginManager.vala:119: Loaded module source: '%s'", _tmp16_);
	_tmp17_ = plug;
	if (_tmp17_ != NULL) {
		GeeHashMap* _tmp18_;
		const gchar* _tmp19_;
		MarlinPluginsBase* _tmp20_;
		_tmp18_ = self->priv->plugin_hash;
		_tmp19_ = file_path;
		_tmp20_ = plug;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, _tmp19_, _tmp20_);
	}
	_marlin_plugins_base_unref0 (plug);
	_g_module_close0 (module);
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static void marlin_plugin_manager_load_plugin_keyfile (MarlinPluginManager* self, const gchar* path, const gchar* parent, gboolean force) {
	GKeyFile* _tmp0_;
	GKeyFile* keyfile;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	g_return_if_fail (parent != NULL);
	_tmp0_ = g_key_file_new ();
	keyfile = _tmp0_;
	{
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
		GKeyFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* name;
		gboolean _tmp5_;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
		gboolean _tmp16_;
		_tmp1_ = keyfile;
		_tmp2_ = path;
		g_key_file_load_from_file (_tmp1_, _tmp2_, G_KEY_FILE_NONE, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch8_g_error;
		}
		_tmp3_ = keyfile;
		_tmp4_ = g_key_file_get_string (_tmp3_, "Plugin", "Name", &_inner_error_);
		name = _tmp4_;
		if (_inner_error_ != NULL) {
			goto __catch8_g_error;
		}
		_tmp5_ = self->priv->in_available;
		if (_tmp5_) {
			GeeList* _tmp6_;
			const gchar* _tmp7_;
			_tmp6_ = self->priv->names;
			_tmp7_ = name;
			gee_collection_add ((GeeCollection*) _tmp6_, _tmp7_);
		}
		_tmp9_ = force;
		if (_tmp9_) {
			_tmp8_ = TRUE;
		} else {
			const gchar* _tmp10_;
			GSettings* _tmp11_;
			const gchar* _tmp12_;
			gchar** _tmp13_;
			gchar** _tmp14_ = NULL;
			gchar** _tmp15_;
			gint _tmp15__length1;
			_tmp10_ = name;
			_tmp11_ = self->priv->settings;
			_tmp12_ = self->priv->settings_field;
			_tmp14_ = _tmp13_ = g_settings_get_strv (_tmp11_, _tmp12_);
			_tmp15_ = _tmp14_;
			_tmp15__length1 = _vala_array_length (_tmp13_);
			_tmp8_ = _vala_string_array_contains (_tmp15_, _vala_array_length (_tmp13_), _tmp10_);
			_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp16_ = _tmp8_;
		if (_tmp16_) {
			GKeyFile* _tmp17_;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_;
			_tmp17_ = keyfile;
			_tmp18_ = g_key_file_get_string (_tmp17_, "Plugin", "File", &_inner_error_);
			_tmp19_ = _tmp18_;
			if (_inner_error_ != NULL) {
				_g_free0 (name);
				goto __catch8_g_error;
			}
			_tmp20_ = parent;
			_tmp21_ = _tmp19_;
			_tmp22_ = g_build_filename (_tmp20_, _tmp21_, NULL);
			_tmp23_ = _tmp22_;
			marlin_plugin_manager_load_module (self, _tmp23_);
			_g_free0 (_tmp23_);
			_g_free0 (_tmp21_);
		}
		_g_free0 (name);
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp24_;
		GError* _tmp25_;
		const gchar* _tmp26_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp24_ = path;
		_tmp25_ = e;
		_tmp26_ = _tmp25_->message;
		g_warning ("PluginManager.vala:144: Couldn't open thie keyfile: %s, %s", _tmp24_, _tmp26_);
		_g_error_free0 (e);
	}
	__finally8:
	if (_inner_error_ != NULL) {
		_g_key_file_unref0 (keyfile);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_key_file_unref0 (keyfile);
}


void marlin_plugin_manager_hook_context_menu (MarlinPluginManager* self, GtkWidget* menu, GList* files) {
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	_tmp0_ = self->menus;
	{
		GList* item_collection = NULL;
		GList* item_it = NULL;
		item_collection = _tmp0_;
		for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
			GtkWidget* _tmp1_;
			GtkWidget* item = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWidget*) item_it->data);
			item = _tmp1_;
			{
				GtkWidget* _tmp2_;
				_tmp2_ = item;
				gtk_widget_destroy (_tmp2_);
				_g_object_unref0 (item);
			}
		}
	}
	__g_list_free__g_object_unref0_0 (self->menus);
	self->menus = NULL;
	{
		GeeHashMap* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_ = NULL;
		GeeIterator* _tmp8_;
		GeeIterator* _plugin_it;
		_tmp3_ = self->priv->plugin_hash;
		_tmp4_ = gee_abstract_map_get_values ((GeeMap*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_plugin_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GeeIterator* _tmp11_;
			gpointer _tmp12_ = NULL;
			MarlinPluginsBase* plugin;
			MarlinPluginsBase* _tmp13_;
			GtkWidget* _tmp14_;
			GList* _tmp15_;
			_tmp9_ = _plugin_it;
			_tmp10_ = gee_iterator_next (_tmp9_);
			if (!_tmp10_) {
				break;
			}
			_tmp11_ = _plugin_it;
			_tmp12_ = gee_iterator_get (_tmp11_);
			plugin = (MarlinPluginsBase*) _tmp12_;
			_tmp13_ = plugin;
			_tmp14_ = menu;
			_tmp15_ = files;
			marlin_plugins_base_context_menu (_tmp13_, _tmp14_, _tmp15_);
			_marlin_plugins_base_unref0 (plugin);
		}
		_g_object_unref0 (_plugin_it);
	}
}


void marlin_plugin_manager_ui (MarlinPluginManager* self, GtkUIManager* data) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (data != NULL);
	{
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _plugin_it;
		_tmp0_ = self->priv->plugin_hash;
		_tmp1_ = gee_abstract_map_get_values ((GeeMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_plugin_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			MarlinPluginsBase* plugin;
			MarlinPluginsBase* _tmp10_;
			GtkUIManager* _tmp11_;
			_tmp6_ = _plugin_it;
			_tmp7_ = gee_iterator_next (_tmp6_);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = _plugin_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			plugin = (MarlinPluginsBase*) _tmp9_;
			_tmp10_ = plugin;
			_tmp11_ = data;
			marlin_plugins_base_ui (_tmp10_, _tmp11_);
			_marlin_plugins_base_unref0 (plugin);
		}
		_g_object_unref0 (_plugin_it);
	}
}


void marlin_plugin_manager_directory_loaded (MarlinPluginManager* self, void* path) {
	g_return_if_fail (self != NULL);
	{
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _plugin_it;
		_tmp0_ = self->priv->plugin_hash;
		_tmp1_ = gee_abstract_map_get_values ((GeeMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_plugin_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			MarlinPluginsBase* plugin;
			MarlinPluginsBase* _tmp10_;
			void* _tmp11_;
			_tmp6_ = _plugin_it;
			_tmp7_ = gee_iterator_next (_tmp6_);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = _plugin_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			plugin = (MarlinPluginsBase*) _tmp9_;
			_tmp10_ = plugin;
			_tmp11_ = path;
			marlin_plugins_base_directory_loaded (_tmp10_, _tmp11_);
			_marlin_plugins_base_unref0 (plugin);
		}
		_g_object_unref0 (_plugin_it);
	}
}


void marlin_plugin_manager_interface_loaded (MarlinPluginManager* self, GtkWidget* win) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (win != NULL);
	{
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _plugin_it;
		_tmp0_ = self->priv->plugin_hash;
		_tmp1_ = gee_abstract_map_get_values ((GeeMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_plugin_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			MarlinPluginsBase* plugin;
			MarlinPluginsBase* _tmp10_;
			GtkWidget* _tmp11_;
			_tmp6_ = _plugin_it;
			_tmp7_ = gee_iterator_next (_tmp6_);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = _plugin_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			plugin = (MarlinPluginsBase*) _tmp9_;
			_tmp10_ = plugin;
			_tmp11_ = win;
			marlin_plugins_base_interface_loaded (_tmp10_, _tmp11_);
			_marlin_plugins_base_unref0 (plugin);
		}
		_g_object_unref0 (_plugin_it);
	}
}


void marlin_plugin_manager_update_sidebar (MarlinPluginManager* self, GtkWidget* win) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (win != NULL);
	{
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _plugin_it;
		_tmp0_ = self->priv->plugin_hash;
		_tmp1_ = gee_abstract_map_get_values ((GeeMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_plugin_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			MarlinPluginsBase* plugin;
			MarlinPluginsBase* _tmp10_;
			GtkWidget* _tmp11_;
			_tmp6_ = _plugin_it;
			_tmp7_ = gee_iterator_next (_tmp6_);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = _plugin_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			plugin = (MarlinPluginsBase*) _tmp9_;
			_tmp10_ = plugin;
			_tmp11_ = win;
			marlin_plugins_base_update_sidebar (_tmp10_, _tmp11_);
			_marlin_plugins_base_unref0 (plugin);
		}
		_g_object_unref0 (_plugin_it);
	}
}


void marlin_plugin_manager_update_file_info (MarlinPluginManager* self, GOFFile* file) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	{
		GeeHashMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _plugin_it;
		_tmp0_ = self->priv->plugin_hash;
		_tmp1_ = gee_abstract_map_get_values ((GeeMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_plugin_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			MarlinPluginsBase* plugin;
			MarlinPluginsBase* _tmp10_;
			GOFFile* _tmp11_;
			_tmp6_ = _plugin_it;
			_tmp7_ = gee_iterator_next (_tmp6_);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = _plugin_it;
			_tmp9_ = gee_iterator_get (_tmp8_);
			plugin = (MarlinPluginsBase*) _tmp9_;
			_tmp10_ = plugin;
			_tmp11_ = file;
			marlin_plugins_base_update_file_info (_tmp10_, _tmp11_);
			_marlin_plugins_base_unref0 (plugin);
		}
		_g_object_unref0 (_plugin_it);
	}
}


void marlin_plugin_manager_add_plugin (MarlinPluginManager* self, const gchar* path) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
}


void marlin_plugin_manager_load_plugin (MarlinPluginManager* self, const gchar* path) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
}


GeeList* marlin_plugin_manager_get_available_plugins (MarlinPluginManager* self) {
	GeeList* result = NULL;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->names;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}


gboolean marlin_plugin_manager_disable_plugin (MarlinPluginManager* self, const gchar* path) {
	gboolean result = FALSE;
	GSettings* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** plugs;
	gint plugs_length1;
	gint _plugs_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_ = NULL;
	gchar** plugs_;
	gint plugs__length1;
	gint _plugs__size_;
	gboolean found;
	gint i;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gboolean _tmp16_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = self->priv->settings;
	_tmp1_ = self->priv->settings_field;
	_tmp3_ = _tmp2_ = g_settings_get_strv (_tmp0_, _tmp1_);
	plugs = _tmp3_;
	plugs_length1 = _vala_array_length (_tmp2_);
	_plugs_size_ = plugs_length1;
	_tmp4_ = plugs;
	_tmp4__length1 = plugs_length1;
	_tmp5_ = g_new0 (gchar*, (_tmp4__length1 - 1) + 1);
	plugs_ = _tmp5_;
	plugs__length1 = _tmp4__length1 - 1;
	_plugs__size_ = plugs__length1;
	found = FALSE;
	i = 0;
	_tmp6_ = plugs;
	_tmp6__length1 = plugs_length1;
	{
		gchar** name_collection = NULL;
		gint name_collection_length1 = 0;
		gint _name_collection_size_ = 0;
		gint name_it = 0;
		name_collection = _tmp6_;
		name_collection_length1 = _tmp6__length1;
		for (name_it = 0; name_it < _tmp6__length1; name_it = name_it + 1) {
			gchar* _tmp7_;
			gchar* name = NULL;
			_tmp7_ = g_strdup (name_collection[name_it]);
			name = _tmp7_;
			{
				const gchar* _tmp8_;
				const gchar* _tmp9_;
				gint _tmp15_;
				_tmp8_ = name;
				_tmp9_ = path;
				if (g_strcmp0 (_tmp8_, _tmp9_) != 0) {
					gchar** _tmp10_;
					gint _tmp10__length1;
					gint _tmp11_;
					const gchar* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					_tmp10_ = plugs;
					_tmp10__length1 = plugs_length1;
					_tmp11_ = i;
					_tmp12_ = name;
					_tmp13_ = g_strdup (_tmp12_);
					_g_free0 (_tmp10_[_tmp11_]);
					_tmp10_[_tmp11_] = _tmp13_;
					_tmp14_ = _tmp10_[_tmp11_];
				} else {
					found = TRUE;
				}
				_tmp15_ = i;
				i = _tmp15_ + 1;
				_g_free0 (name);
			}
		}
	}
	_tmp16_ = found;
	if (_tmp16_) {
		GSettings* _tmp17_;
		const gchar* _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		_tmp17_ = self->priv->settings;
		_tmp18_ = self->priv->settings_field;
		_tmp19_ = plugs_;
		_tmp19__length1 = plugs__length1;
		g_settings_set_strv (_tmp17_, _tmp18_, _tmp19_);
	}
	result = found;
	plugs_ = (_vala_array_free (plugs_, plugs__length1, (GDestroyNotify) g_free), NULL);
	plugs = (_vala_array_free (plugs, plugs_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void marlin_plugin_manager_class_init (MarlinPluginManagerClass * klass) {
	marlin_plugin_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MarlinPluginManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = marlin_plugin_manager_finalize;
}


static void marlin_plugin_manager_instance_init (MarlinPluginManager * self) {
	self->priv = MARLIN_PLUGIN_MANAGER_GET_PRIVATE (self);
	self->priv->in_available = FALSE;
}


static void marlin_plugin_manager_finalize (GObject* obj) {
	MarlinPluginManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARLIN_TYPE_PLUGIN_MANAGER, MarlinPluginManager);
	_g_object_unref0 (self->priv->plugin_hash);
	_g_object_unref0 (self->priv->settings);
	_g_free0 (self->priv->settings_field);
	_g_free0 (self->priv->plugin_dir);
	_g_object_unref0 (self->priv->names);
	__g_list_free__g_object_unref0_0 (self->menus);
	G_OBJECT_CLASS (marlin_plugin_manager_parent_class)->finalize (obj);
}


GType marlin_plugin_manager_get_type (void) {
	static volatile gsize marlin_plugin_manager_type_id__volatile = 0;
	if (g_once_init_enter (&marlin_plugin_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MarlinPluginManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marlin_plugin_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MarlinPluginManager), 0, (GInstanceInitFunc) marlin_plugin_manager_instance_init, NULL };
		GType marlin_plugin_manager_type_id;
		marlin_plugin_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "MarlinPluginManager", &g_define_type_info, 0);
		g_once_init_leave (&marlin_plugin_manager_type_id__volatile, marlin_plugin_manager_type_id);
	}
	return marlin_plugin_manager_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



